<?php

/**
 * Back-end of Flexslider_XH.
 * Copyright (c) 2014 svasti@svasti.de
 */


if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}


/**
 * Plugin administration
 */
initvar('flexslider');
if ($flexslider) {
    initvar('admin');
    initvar('action');
    $admin  = isset($_POST['admin']) ? $_POST['admin'] : $admin = isset($_GET['admin']) ? $_GET['admin'] : '';
    $action = isset($_POST['action']) ? $_POST['action'] : $action = isset($_GET['action']) ? $_GET['action'] : '';

    $o .= print_plugin_admin('on');
    $fx_path=$pth['folder']['images'].trim($plugin_cf['flexslider']['image_path'],'/').'/';

    // fill list of images
    //=================================
    if($action=='fill_flexslider')  {

        if ($handle = opendir($fx_path)) {
            while (false !== ($file = readdir($handle))) {
                if ($file != '.' && $file != '..' && !is_dir($fx_path.$file)) {
                    $newimages[] = $file;
                }
            }
            closedir($handle);
        }

        $imagearray = explode(';',$plugin_tx['flexslider']['imagelist']);
        foreach ($imagearray as $key=>$value) {
            $i = array();
            $i = explode('|',$value);
          	$presentimages[] =  $i[0];
        }

        foreach ($newimages as $key=>$value) {
            foreach ($presentimages as $key2=>$value2) {
                if ($value == $value2) unset($newimages[$key]);
            }
        }

        $newfx = implode(';',$newimages);
        $newfx = ($plugin_tx['flexslider']['imagelist'] && $newfx)? ';'.$newfx : $newfx;

        $oldlangfile = file_get_contents($pth['folder']['plugins'] . 'flexslider/languages/'.$sl.'.php');
        $oldlangfile = !preg_match('!page_on_error\'\]="(.*)";!' ,$oldlangfile)
              ? str_replace('?>',"\t".'$plugin_tx[\'flexslider\'][\'imagelist\']="";'."\n?>" ,$oldlangfile)
              : $oldlangfile;

        $pattern = '!imagelist\'\]="(.*)";!';
        $replacement = 'imagelist\']="${1}'.$newfx.'";';
        $newlangfile = preg_replace($pattern,$replacement,$oldlangfile);
        file_put_contents($pth['folder']['plugins'] . 'flexslider/languages/'.$sl.'.php',$newlangfile);
        include $pth['folder']['plugins'] . 'flexslider/languages/'.$sl.'.php';
    }

    // receiving and saving changes
    // ============================================================================
    if($action=='save_flexslider')  {

        $fx['up']      =isset($_POST['up']) ?      $_POST['up']      : array();
        $fx['delete']  =isset($_POST['delete']) ?  $_POST['delete']  : array();
        $fx['image']   =isset($_POST['image']) ?   $_POST['image']   : array();
        $fx['text']    =isset($_POST['text']) ?    $_POST['text']    : array();
        $fx['link']    =isset($_POST['link']) ?    $_POST['link']    : array();
        $fx['extlink'] =isset($_POST['extlink']) ? $_POST['extlink'] : array();

        // Move UP
        $upkey = array_search(TRUE, $fx['up']);
        if($upkey > 0 || $upkey === 0) {
            foreach ($fx as $key=>$value) {
                // extract values
                $moving_up = array_slice($fx[$key],$upkey,1);
                // delete extracted values in the original array
                array_splice($fx[$key],$upkey,1);
                // add extracted value higher into the original array
                if($upkey > 0) array_splice($fx[$key],($upkey - 1),0,$moving_up);
                if($upkey === 0) array_splice($fx[$key],count($fx),0,$moving_up);
            }
        }

        // Delete
        $delkey = array_search(TRUE, $fx['delete']);
        if($delkey > 0 || $delkey === 0) {
            foreach ($fx as $key=>$value) {
                array_splice($fx[$key],$delkey,1);
            }
        }

        // Prepare the new values for saving in config.php
        $newfx='';
        foreach ($fx['image'] as $key=>$value) {
        	$newfx .= $fx['image'][$key].'|';
        	$newfx .= isset($fx['text'][$key])
                    ? str_replace('"','\'',stsl($fx['text'][$key])).'|'
                    : '|';
            $newfx .= isset($fx['link'][$key]) && $fx['link'][$key] && $fx['link'][$key] != 'ext'
                    ? '?'. stsl($fx['link'][$key])
                    : '';
            if(isset($fx['link'][$key]) && $fx['link'][$key] == 'ext' && $fx['extlink'][$key]) {
                $newfx .= strpos($fx['extlink'][$key],'http')===0
                        ? $fx['extlink'][$key]
                        : 'http://'.$fx['extlink'][$key];
            }
             $newfx .= isset($fx['image'][($key+1)]) ? ';':'';
        }

        $oldlangfile = file_get_contents($pth['folder']['plugins'] . 'flexslider/languages/'.$sl.'.php');
        $pattern = '!imagelist\'\]="(.*)";!';
        $replacement = 'imagelist\']="'.$newfx.'";';
        $newlangfile = preg_replace($pattern,$replacement,$oldlangfile);

        file_put_contents($pth['folder']['plugins'] . 'flexslider/languages/'.$sl.'.php',$newlangfile);
        include $pth['folder']['plugins'] . 'flexslider/languages/'.$sl.'.php';
    }


    // view image list in admin mode
    //================================
    if (!$admin || $admin=='plugin_main') {

    $o .= '<h5>Flexslider_XH '.$plugin_cf['flexslider']['version']
       .  '<small><small> by <a href="http://svasti.de" target="_blank">svasti</a> &nbsp; '
       .  tag('input type="button" value="license?" style="font-size:80%;" OnClick="
          if(document.getElementById(\'license\').style.display == \'none\') {
              document.getElementById(\'license\').style.display = \'inline\';
              } else {
              document.getElementById(\'license\').style.display = \'none\';
              }
          "')
       . '</small></small></h5>' . "\n"
       . '<p id="license" style="display:none;">'
       . 'This plugin is free software under the terms of the GNU General Public License v. 3 or '
       . 'later, analog to <a href="' . $sn . '?' . uenc($cf['menu']['legal']) . '">'
       . $cf['menu']['legal'] . '</a>'. tag('br')
       . '<b>Acknowledgements:</b>'.tag('br')
       . 'This plugin uses jQuery/Flexslider 2.2 by <a href="http://twitter.com/mbmufffin" target="_blank">Tyler Smith</a>'. tag('br')
       . tag('br').'</p>'. "\n\n" ;

    $o .= '<form method="POST" action="' . $sn
        .  '?&flexslider&amp;admin=plugin_main&amp;action=fill_flexslider">'
        .  '<button type="submit">'
        .  $plugin_tx['flexslider']['fill-up']
        .  '</button>'
        .  '</form>';


        if($plugin_tx['flexslider']['imagelist']) {

            $imagearray = explode(';',$plugin_tx['flexslider']['imagelist']);

            $o .= '<form method="POST" action="' . $sn
                .  '?&flexslider&amp;admin=plugin_main&amp;action=save_flexslider">';

             // start table for entering config data
             //=====================================
             $o .= "\n".'<table style="width:100%;background:#eee;border:.1em solid #555;">';


            foreach ($imagearray as $key=>$value) {
                $i = array();
                $i = explode('|',$value);

              	$image =  $pth['folder']['images']
                       .  trim($plugin_cf['flexslider']['image_path'].'/').'/'
                       .  $i[0];
                $text  =  (isset($i[1]) && $i[1])? trim($i[1]) : '';
                $link  =  (isset($i[2]) && $i[2])? trim($i[2]) : '';
                list($width, $height) = getimagesize($image);

                $o .= "\n"
                        //1st row 1st td
                   .  '<tr>'
                   .  '<td style="width:1em;">'
                   .  tag('input type="image" src="'.$pth['folder']['plugins']
                   .  'flexslider/images/up.gif" style="width:15px;height:20px;" value="true" name="up['.$key.']"  alt="up" title="'
                   .  'Move image one step up"')
                   .  tag('br') . "\n"
                   .  tag('input type="image" src="'.$pth['folder']['plugins']
                   .  'flexslider/images/delete.gif" style="width:15;height:15" value="true" name="delete['.$key.']" title="'
                   .  'Delete image from Flexslider list" value=TRUE alt="Delete entry"')
                   .  "\n"
                        //1st row 2nd td
                   .  '<td style="width:155px;">' . tag('img src="'.$image.'" width="150"')
                   .  tag('input type="hidden" value="'.$i[0].'" name="image['.$key.']"')
                        //1st row 3nd td
                   .  '</td><td>'
                        // table2 1st row 1st td
                   .  '<table style="width:100%"><tr><td style="width:3em;">'
                   .  "\n"
                   .  'File: '
                        // table2 1st row 2st td
                   .  '</td><td>'
                   .  "\n"
                   .  '<b>'.$i[0].'</b> '.$width.' x '.$height.' px, '.round(filesize($image) / 1024,1).' kB'
                   .  '</td>'
                   .  '</tr>'
                   .  "\n"
                     //2nd row 1rd td
                   .  '<tr><td>'
                   .  "\n"
                   .  'Text: '
                     //2nd row 4th td
                   .  '</td><td>'
                   .  "\n"
                   .  tag('input type="text" style="width:97%;" value="'.$text.'" name="text['.$key.']"')
                   .  "\n"
                   .  '</td></tr>'
                   .  "\n"
                     // 3rd row 3rd td
                   .  '<tr><td>'
                   .  "\n"
                   .  'Link: '
                   .  "\n"
                     // 3rd row 4th td
                   .  '</td><td>';

                $pages_select = '';
                $x = 0;
                for ($i = 0; $i < $cl; $i++) {
                    $selected = '';
                    if(substr($link,1) == $u[$i]) {$selected = ' selected="selected"'; $x++;}
                    $levelindicator = '';
                    for ($j = 1; $j < $l[$i]; $j++) {$levelindicator .= '&ndash;&nbsp;';}
                    $page = $levelindicator.$h[$i];
                    $page = strlen($page)>45? substr($page,0,43).'...':$page;
                    $pages_select .= '<option value="'.$u[$i].'"'.$selected.'>'."\n".$page.'</option>';
                }
                $selected = $extlinkinput = $extlink = '';
                $extlinkinput = 'display:none;';
                if($link && !$x) {
                    $extlinkinput = 'display:inline;';
                    $selected     = ' selected';
                    $extlink      = $link;
                }
                $goto_extlink = '<option value="ext"'.$selected.'> External Link </option>';


                $o .= '<select name="link['.$key.']" OnChange="
                       if(this.options[this.selectedIndex].value == \'ext\') {
                           document.getElementById(\'extlink['.$key.']\').style.display = \'inline\';
                       } else {
                           document.getElementById(\'extlink['.$key.']\').style.display = \'none\';
                       } ; ">'
                   .  "\n"
                   .  '<option value=""> No Link </option>'
                   .  "\n"
                   .  $goto_extlink
                   .  "\n"
                   .  $pages_select . '</select>'
                   .  tag('br')
                   .  tag('input type="text" style="'.$extlinkinput.';width:97%;" name="extlink['.$key.']" id="extlink['.$key.']" placeholder="'
                   .  'Enter external link" value="' . $extlink . '"');

                $o .= '</td></tr></table></td></tr>';

            } 

            $o .= "\n".'</table>'
               .  "\n".tag('input type="submit" value="'.ucfirst($tx['action']['save']).'"').tag('br')
               .  "\n".'</form>'."\n";

        } 

    } else {
        // rest of plugin menu
        $o .= plugin_admin_common($action, $admin, $plugin);
    }

}

?>
