<?php

/**
 * Front-end of Flexslider_XH.
 *
 * PHP versions 4 and 5
 *
 * @category  CMSimple_XH
 * @author    svasti <svasti@svasti.de>
 * @copyright 2014 svasti <http://svasti.de>
 * @version   0.1
 */

/*
 * Prevent direct access.
 */
if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}

function flexslider()
{
    global $plugin_cf,$plugin_tx,$hjs,$pth;
    $images = $o = '';

    include_once($pth['folder']['plugins'].'jquery/jquery.inc.php');
    include_jQuery();
    include_jQueryPlugin('flexslider-min', $pth['folder']['plugins'].'flexslider/js/jquery.flexslider-min.js');

    $speed_slideshow = $plugin_cf['flexslider']['speed_slideshow']? 'slideshowSpeed: '.$plugin_cf['flexslider']['speed_slideshow'].",\n":'';
    $speed_animation = $plugin_cf['flexslider']['speed_animation']? 'animationSpeed: '.$plugin_cf['flexslider']['speed_animation'].",\n":'';
    $pauseOnHover    = $plugin_cf['flexslider']['pauseOnHover']   ? 'pauseOnHover: true'.",\n":'';

        $hjs .= '<script type="text/javascript">
    // Can also be used with $(document).ready()
    $(window).load(function() {
      $(\'.flexslider\').flexslider({
        ' . $speed_slideshow
          . $speed_animation
          . $pauseOnHover
          . 'animation: "slide",
         prevText: "",
         nextText: ""
      });
    });
    </script>';

    if(!is_dir($pth['folder']['images'].trim($plugin_cf['flexslider']['image_path'],'/').'/'))
        e('missing','folder',$pth['folder']['images'].trim($plugin_cf['flexslider']['image_path'],'/').'/');
    if(!$plugin_tx['flexslider']['imagelist'])
        e('missing','image list');

    $imagearray = explode(';',$plugin_tx['flexslider']['imagelist']);

    foreach ($imagearray as $key=>$value) {
        $i = array();
        $i = explode('|',$value);

    	$images .= "\n<li>";
        if(isset($i[2]) && $i[2]) $images .='<a href="'.$i[2].'">';'</a>';
      	$images .= tag('img src="'
                .  $pth['folder']['images']
                .  trim($plugin_cf['flexslider']['image_path'],'/').'/'
                .  $i[0]
                . '"');
        if(isset($i[1]) && $i[1]) $images .= '<p class="flex-caption">' . trim($i[1]) . '</p>';
        if(isset($i[2]) && $i[2]) $images .='</a>';
        $images .= '</li>';
     }

    $o .= "\n\n\n<!-- F L E X S L I D E R   S T A R T -->\n\n"
       .   '<div class="flexslider">'
       .  '<ul class="slides">'
       .  $images
       .  '</ul>'
       .  '</div>'
       .  "\n<!-- F L E X S L I D E R   E N D -->\n\n";

    return $o;
}
?>
